<?php

class WPSFG_ConfigurationPage {

	static function getPage()
	{
		?>
		<div class="wrap wpsfg-config">
			<form action="<?php echo admin_url('admin.php?page=' . $GLOBALS['WPSFG']->pluginSlug)?>" method="post">
				<div class="wpsfg-header">
					<h1 class="heading-top"><strong><?php echo sprintf( esc_html__( '%s', 'wpsfg' ), $GLOBALS['WPSFG']->pluginName ) ?></strong> <small><?php echo sprintf( esc_html__( 'v %s', 'wpsfg' ), $GLOBALS['WPSFG']->pluginVersion ) ?></small></h1>
					<div class="wpsfg-header-link">
						<a class="link-button" href="https://www.wddportfolio.com/contact-us/" target="_blank"><i class="dashicons dashicons-sos"></i> <?php _e( 'Support Portal', 'wpsfg' ) ?></a>
					</div>
				</div>

				<div class="wpsfg-body">

					<?php echo $this->drawOptions(array(
						array( 
							'type'			=> 'text', 
							'name'			=> 'wpsfg-username', 
							'title'			=> esc_html__( 'Instagram Username', 'wpsfg' ), 
							'description'	=> esc_html__( 'Enter a fallback username', 'wpsfg' ) . '<br><small>' . esc_html__( 'e.g. instagram', 'wpsfg' ) . '</small>', 
						),
						array( 
							'type'			=> 'toggle', 
							'name'			=> 'wpsfg-load-css', 
							'title'			=> esc_html__( 'Load Stylesheet', 'wpsfg' ), 
							'description'	=> esc_html__( 'When this option is on, this plugin add own pre-defined stylesheet to the frontend. When it is off, you have to add your own stylesheet.', 'wpsfg' )
						),
					));?>

					<div class="wpsfg-option-section wpsfg-option-section-button">
						<button type="submit" class="wpsfg-option-button"><i class="dashicons dashicons-yes-alt"></i> <?php _e( 'Save Settings', 'wpsfg' );?></button>
					</div>

					<input type="hidden" name="nonce"  class="wpsfg-hidden-control" value="<?php echo wp_create_nonce( $GLOBALS['WPSFG']->pluginSlug ); ?>">
					<input type="hidden" name="action" class="wpsfg-hidden-control" value="wpsfg-save">

				</div>
			</form>
		</div>
		<?php
	}

	private static function drawOptions(array $options)
	{

		$output = '';

		$optionValues = $GLOBALS['WPSFG']->getSettings();

		foreach( $options as $option )
		{
			//$output .= '<pre>'.print_r($option, true).'</pre>';
			$output .= '<div class="wpsfg-option-section"><div class="wpsfg-option-section-info"><h4 class="wpsfg-option-section-info-name"><label for="'.$option['name'].'">'.$option['title'].'</label></h4>';
			if ( isset($option['description']) && !empty($option['description']) ){
				$output .= '<div class="wpsfg-option-section-info-caption">'.$option['description'].'</div>';
			}
	        $output .= '</div><div class="wpsfg-option-section-container">';

	        $function   = str_replace(' ', '', ucwords(str_replace('_', ' ', $option['type'])));
	        $optionFunc = 'drawOption'.$function;
	        if ($option['type'] == 'dropdown'){
	        	$output .= self::{$optionFunc}( $option['name'], $optionValues[ $option['name'] ], $option['option'] );
	        }else{
	        	$output .= self::{$optionFunc}( $option['name'], $optionValues[ $option['name'] ] );
	        }

	        $output .= '</div></div>';
		}

		return $output;

	}

	private static function drawOptionText($option_name, $option_value='')
	{
		return "<input type=\"text\" name=\"{$option_name}\" value=\"{$option_value}\" id=\"{$option_name}\" class=\"wpsfg-input-field\">";
	}

	private static function drawOptionToggle($option_name, $option_value='')
	{
		$option_on  = esc_html__( 'ON' , 'wpsfg' );
		$option_off = esc_html__( 'OFF', 'wpsfg' );
		return "<input type=\"checkbox\" name=\"{$option_name}\" value=\"true\" id=\"{$option_name}\" class=\"wpsfg-input-toggle\" ".checked( (boolean) $option_value, true, false )."><label for=\"{$option_name}\" data-on=\"{$option_on}\" data-off=\"{$option_off}\"><i></i></label>";
	}

	private static function drawOptionDropdown($option_name, $option_value='', $option_dropdown = array())
	{
		$output  = "<select name=\"{$option_name}\" value=\"true\" id=\"{$option_name}\" class=\"wpsfg-dropdown\">";
		//$output .= '<option value="">' . esc_html__( 'Select One', 'wpsfg' ) . '</option>';
		foreach ($option_dropdown as $option_id=>$option_text){
			$output .= '<option value="' . $option_id . '" '. selected($option_id, $option_value, false) .'>' . $option_text . '</option>';
		}
		$output .= "</select>";
		return $output;
	}
}